--
-- All separate parts have to be in groups with proper name without "_0" and prefix
--

--NO_MORPHING = 1
MORPHING_SRC = 2
MORPHING_DST = 3

Prefix	= "TMP"
--DestDir = "D:\\3dsmax6\\Meshes\\TMP\\"


Utility XRPartsExporter "XRPartsExporter"
(
	label lblCarID "Car's ID" pos:[8,16] width:66 height:15
	editText edtCarID "" pos:[88,16] width:64 height:16
	label lblDestDir "Destination directory:" pos:[8,48] width:144 height:16
	editText edtDestDir "" pos:[8,72] width:120 height:16 enabled:true
	radioButtons rdoExport "Export type:" pos:[30,104] width:102 height:62 labels:#("No morphing", "Morphing source", "Morphing target") default:1 columns:1
	button btnExport "Export" pos:[8,216] width:144 height:40
	button btnBrowse "..." pos:[128,72] width:24 height:16
	checkbox chkDelLogs "Delete logs" pos:[39,184] width:83 height:16 checked:true

--------
	on XRPartsExporter open do
	(
		edtCarID.text = Prefix
		edtDestDir.text  = (GetDir #export) + "\\"
	) 
	on btnBrowse pressed do
	(
		Dir = getSavePath caption:"Destination directory:"
		if Dir != undefined then 
		(
			Dir = Dir + "\\"
			edtDestDir.text  = Dir
		)
	)
	on btnExport pressed do
	(
		plugcfg = GetDir #plugcfg
		
		f = openfile (plugcfg+"\\animexp.ini") mode:"w"
		head = "!LightingType(s)\n!NoGeometry()\n!NoAnimation()\n!Morphing(s)\n\nLightingType(\"no lighting\")\n"
		format "%" head to: f 
		case rdoExport.state of
		(
			MORPHING_SRC:
			(
				s = "Morphing(\"src\")\n"
				format "%" s to: f
			)			
			MORPHING_DST: 
			(
				s = "Morphing(\"dst\")\n"
				format "%" s to: f
			)			
		)		
		close f
		Export()
	)
		
)

--- functions
function	UnhideAllChildren obj =
(
	for i = 1 to obj.children.count do
	(
		Unhide( obj.children[i] )
		if obj.children[i].children.count>0 do UnhideAllChildren obj.children[i]
	)
)

function	HideAllChildren obj =
(
	for i = 1 to obj.children.count do
	(
		Hide( obj.children[i] )
		if obj.children[i].children.count>0 do HideAllChildren obj.children[i]
	)
)

function	HideAllGroups =
(
	for i = 1 to helpers.count do
	(
		if isGroupHead helpers[i] then
		(
			Hide( helpers[i] )
			HideAllChildren helpers[i]
		)
	)
)

function Export  =
(
	--max hold
	HideAllGroups()
	f = XRPartsExporter.edtDestDir.text + XRPartsExporter.edtCarID.text
	ExportFile(f + ".3da") #noprompt
	if XRPartsExporter.rdoExport.state == MORPHING_DST then
	(	
		deleteFile (f + ".3da")
		renameFile (f+".3da_0.3da") (f + ".3da")
		deleteFile (f + "_D.3da")
		renameFile (f+".3da_1.3da") (f + "_D.3da")
	)

	max select all
	max hide selection

	for i= 1 to helpers.count do
	(
		if isGroupHead helpers[i]  then
		(
			UnhideAllChildren helpers[i]
		  	oldPos = helpers[i].Pos
		  	helpers[i].Pos = [0, 0, 0]
		  	f = XRPartsExporter.edtDestDir.text + XRPartsExporter.edtCarID.text + "_" + helpers[i].name
			exportFile(f + ".3da") #noprompt
			if XRPartsExporter.rdoExport.state == MORPHING_DST then
			(
				if deleteFile(f + ".3da") then print "ok" 
				renameFile (f+".3da_0.3da") (f + ".3da")
				deleteFile(f + "_D.3da")					
				renameFile (f+".3da_1.3da") (f + "_D.3da")
				--DOSCommand("rmdir /S /Q " + "\"" + f + "\""	+ ".3da_0.3da_dir")
			)
		  	helpers[i].Pos = oldPos
		  	max select all
		  	max hide selection
		)
	)
	if XRPartsExporter.chkDelLogs.checked then 
	(
		--DeleteFile(edtDestDir.text+"*.3da.log")
		DOSCommand("del " + "\"" + XRPartsExporter.edtDestDir.text + "\"" + "*.log")
	)
	--max fetch
)
		


